## kadu 3.0~rc1

=== CMakeLists.txt ===
project (Kadu)

cmake_minimum_required (VERSION 2.8.11)

# Options (some of them)

option (ENABLE_DEVELOPER_BUILD "Turn on some features helpful during development process (has nothing to do with debugging symbols)" OFF)
option (INSTALL_SDK "Install SDK (API headers, CMake modules, MSVC program libraries)" ON)
option (BUILD_TESTING "Build the test suite." "${ENABLE_DEVELOPER_BUILD}")
option (WINDOWS_ARCHITECTURE "Architecture for Windows binaries." "x86")

# Global CMake variables

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)

if (NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	if (ENABLE_DEVELOPER_BUILD)
		set (default Debug)
	else ()
		set (default RelWithDebInfo)
	endif ()

	set (CMAKE_BUILD_TYPE "${default}" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# C++11 support, warnings and other flags

set (DEFINITIONS QT_USE_QSTRINGBUILDER QT_NO_CAST_TO_ASCII QT_DISABLE_DEPRECATED_BEFORE=0x040900)
if (BUILD_TESTING)
	list (APPEND DEFINITIONS KADU_EXPORT_TESTS)
endif ()
set (DEFINITIONS_DEBUG DEBUG_ENABLED DEBUG_OUTPUT_ENABLED)

if (MSVC)
	set (COMMON_COMPILE_FLAGS "/MP /Zc:wchar_t-")
	list (APPEND DEFINITIONS _CRT_SECURE_NO_WARNINGS=1)
else ()
	set (COMMON_COMPILE_FLAGS "-Wall -Wextra -Wundef -Wunused -Wuninitialized -Wcast-align -Wpointer-arith -fno-common")
	set (C_FLAGS "-Wwrite-strings")
	set (CXX_FLAGS "-Woverloaded-virtual -Wnon-virtual-dtor -std=c++0x")
	set (CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")

	if (NOT WIN32)
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -fvisibility=hidden")
		set (CXX_FLAGS "${CXX_FLAGS} -fvisibility-inlines-hidden")
	endif ()

	# Qt 4.8.5 cannot detect Clang's C++11 features, it depends on
	# detected GCC version, anc Clang mimics GCC 4.2.1. Let's mimic
	# GCC 4.8.1.
	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -U__GNUC_MINOR__ -D__GNUC_MINOR__=8")
	endif ()

	if (ENABLE_DEVELOPER_BUILD)
		# -pipe can speed up the build
		# -ftrapv generates trap on signed integer overflow, which is undefined by C/C++
		# -fno-omit-frame-pointer gives potentially better stack traces at the cost of negligible performance drop
		set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -Werror -Wno-deprecated -pipe -ftrapv -fno-omit-frame-pointer")

		if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set (SANITIZE_OPTIONS "-fsanitize=integer -fsanitize=undefined-trap -fsanitize=unsigned-integer-overflow")
			set (COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} ${SANITIZE_OPTIONS} -fsanitize-blacklist=${CMAKE_SOURCE_DIR}/sanitize-blacklist.txt")
			set (LINK_FLAGS "${LINK_FLAGS} ${SANITIZE_OPTIONS}")
			# Clang is links its sanitizer libraries only to executables,
			# even though they are actually needed all over the code. :-(
			set (ALLOW_UNDEFINED ON)
		endif ()

		if (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU")
			# -z now checks there are no unresolved symbols at executalbe/library load time, instead of that specific symbol load time
			set (LINK_FLAGS "${LINK_FLAGS} -Wl,-z,now -Wl,--as-needed")
		endif ()
	endif ()

	if (NOT ALLOW_UNDEFINED AND (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "GNU"))
		set (LINK_FLAGS "${LINK_FLAGS} -Wl,--no-undefined")
	endif ()
endif ()

# Look above, DEBUG_ENABLED is always enabled in Debug configuration.
# Enable it in all configurations when ENABLE_DEVELOPER_BUILD is on.
if (ENABLE_DEVELOPER_BUILD)
	list (APPEND DEFINITIONS DEBUG_ENABLED)
endif ()

# The same notes as DEBUG_ENABLED concern also DEBUG_OUTPUT_ENABLED.
# Additionally, Windows needs DEBUG_OUTPUT_ENABLED because we always
# install kadu_c.exe with console output.
if (ENABLE_DEVELOPER_BUILD OR WIN32)
	list (APPEND DEFINITIONS DEBUG_OUTPUT_ENABLED)
endif ()

# Version information

file (STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" KADU_VERSION LIMIT_COUNT 1)

find_package (Git QUIET)
if (GIT_FOUND)
	execute_process (COMMAND "${GIT_EXECUTABLE}" describe --tags --exact-match HEAD
		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
		RESULT_VARIABLE result
		OUTPUT_VARIABLE git_tag
		ERROR_QUIET
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (NOT (result STREQUAL 0) OR NOT (git_tag STREQUAL KADU_VERSION))
		execute_process (COMMAND "${GIT_EXECUTABLE}" rev-parse --short --verify HEAD
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			RESULT_VARIABLE result
			OUTPUT_VARIABLE git_commit
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)

		if (result STREQUAL 0)
			set (KADU_VERSION "${KADU_VERSION}-g${git_commit}")
		endif ()
	endif ()
endif ()

string (REGEX REPLACE "-.*" "" simple_version ${KADU_VERSION})

if (NOT KADU_VERSION STREQUAL simple_version)
	set (KADU_PRERELEASE TRUE)
endif ()

# Installation paths.

set (INSTALL_SDK_DIR "" CACHE PATH "SDK installation root")
mark_as_advanced (INSTALL_SDK_DIR)
if (NOT INSTALL_SDK_DIR)
	set (INSTALL_SDK_DIR "${CMAKE_INSTALL_PREFIX}/sdk")
	set (install_sdk_dir_set_to_default TRUE)
endif ()

include (GNUInstallDirs)

set (INSTALL_BIN_DIR "${CMAKE_INSTALL_FULL_BINDIR}")
set (INSTALL_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set (INSTALL_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/kadu")
set (INSTALL_PLUGINS_DATA_DIR "${INSTALL_DATA_DIR}/plugins")
set (INSTALL_PLUGINS_LIB_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/kadu/plugins")
set (INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/kadu")
set (INSTALL_CMAKE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/cmake/Kadu")

if (install_sdk_dir_set_to_default)
	set (INSTALL_SDK_DIR "${INSTALL_DATA_DIR}/sdk")
endif ()

if (WIN32)
	set (KADU_DATADIR_RELATIVE_TO_BIN "./")
	set (KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "./plugins/")
else ()
	file (RELATIVE_PATH KADU_DATADIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_DATA_DIR}")
	file (RELATIVE_PATH KADU_PLUGINS_LIBDIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${INSTALL_PLUGINS_LIB_DIR}")
endif ()

if (UNIX AND NOT APPLE)
	set (DESKTOP_FILE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/applications")
	set (DESKTOP_FILE_NAME kadu.desktop)

	file (RELATIVE_PATH KADU_DESKTOP_FILE_DIR_RELATIVE_TO_BIN "${INSTALL_BIN_DIR}" "${DESKTOP_FILE_DIR}")
endif ()

set (install_vars
	INSTALL_SDK_DIR INSTALL_BIN_DIR INSTALL_LIB_DIR INSTALL_DATA_DIR INSTALL_PLUGINS_DATA_DIR
	INSTALL_PLUGINS_LIB_DIR INSTALL_INCLUDE_DIR INSTALL_CMAKE_DIR
)
foreach (install_var ${install_vars})
	if (NOT DEFINED ${install_var})
		message (FATAL_ERROR "Variable ${install_var} does not exist")
	else ()
		if (IS_ABSOLUTE "${${install_var}}")
			file (TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" sane_install_prefix)
			file (TO_CMAKE_PATH "${${install_var}}" sane_install_path)
			if (sane_install_path STREQUAL sane_install_prefix)
				set (RELATIVE_${install_var} "")
			else ()
				string (REPLACE "${sane_install_prefix}/" "" RELATIVE_${install_var} "${sane_install_path}")
			endif ()
			if (RELATIVE_${install_var} STREQUAL "")
				set (RELATIVE_${install_var} ".")
			endif ()

			if (IS_ABSOLUTE "${RELATIVE_${install_var}}")
				message (FATAL_ERROR "${install_var} (${${install_var}}) is not under install prefix.")
			endif ()
		else ()
			set (RELATIVE_${install_var} "${${install_var}}")
		endif()
	endif ()
endforeach ()

set (KADU_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (path_vars KADU_INSTALL_PREFIX)
if (UNIX AND NOT APPLE)
	list (APPEND path_vars DESKTOP_FILE_DIR)
endif ()

# Generate CMake configuration files

include (CMakePackageConfigHelpers)

macro (kadu_configure_package_config_file _in _out _mode)
	if ("${_mode}" STREQUAL BUILD_TREE)
		foreach (path_var ${path_vars})
			set (PACKAGE_${path_var} "${${path_var}}")
		endforeach ()

		set (PACKAGE_INCLUDE_DIR "${CMAKE_SOURCE_DIR}")
		set (PACKAGE_SDK_DIR "${CMAKE_SOURCE_DIR}")

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	elseif ("${_mode}" STREQUAL INSTALL_TREE)
		set (INCLUDE_DIR "${INSTALL_INCLUDE_DIR}")
		set (SDK_DIR "${INSTALL_SDK_DIR}")
		list (APPEND path_vars INCLUDE_DIR SDK_DIR)

		configure_package_config_file ("${_in}" "${_out}"
			INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
			PATH_VARS ${path_vars}
			NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO
		)
	endif ()
endmacro ()

# This one is only for usable within the build tree. We want to actually
# set some variables in there from within the subdirectories, so we generated
# the intallation version later.
kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
	"${CMAKE_BINARY_DIR}/KaduConfig.cmake" BUILD_TREE)

write_basic_package_version_file ("${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
	VERSION ${simple_version} COMPATIBILITY AnyNewerVersion
)

# Include the generated file

set (Kadu_DIR "${CMAKE_BINARY_DIR}")
find_package (Kadu REQUIRED CONFIG)

if (NOT WIN32)
	include (CheckIncludeFiles)

	# TODO: Add libexecinfo support
	check_include_files ("execinfo.h" HAVE_EXECINFO)
	if (HAVE_EXECINFO)
		include (CheckFunctionExists)

		check_function_exists ("backtrace" HAVE_EXECINFO)
	endif ()
endif ()

include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/kadu-core)

add_subdirectory (kadu-core)
add_subdirectory (varia)
add_subdirectory (translations)

include (Plugins.cmake)
add_subdirectory (plugins)

if (BUILD_TESTING)
	enable_testing ()
	add_subdirectory (tests)
endif ()

add_subdirectory (kthxbye)

# Now write KaduConfig for installation.
if (UNIX)
	kadu_configure_package_config_file (cmake/KaduConfig.cmake.in
		"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake" INSTALL_TREE)
endif ()

if (KADU_INSTALL_SDK)
	install (FILES
		"${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/KaduConfig.cmake"
		"${CMAKE_BINARY_DIR}/KaduConfigVersion.cmake"
		cmake/KaduMacros.cmake
		DESTINATION "${KADU_INSTALL_CMAKE_DIR}"
	)

	install (EXPORT KaduTargets DESTINATION "${KADU_INSTALL_CMAKE_DIR}")
endif ()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

configure_file (varia/scripts/nsis_installer.nsi.in "${CMAKE_CURRENT_BINARY_DIR}/nsis_installer.nsi" ESCAPE_QUOTES @ONLY)

message (STATUS "Kadu (version: ${KADU_VERSION}) will be built:")
message (STATUS " * install prefix: ${CMAKE_INSTALL_PREFIX}")
if (NOT DEFINED CMAKE_CONFIGURATION_TYPES)
	message (STATUS " * build type: ${CMAKE_BUILD_TYPE}")
endif ()

install (FILES AUTHORS AUTHORS.html HISTORY README THANKS ChangeLog ChangeLog.OLD-PL DESTINATION "${KADU_INSTALL_DATA_DIR}")
# For Win32 we use GPL3, and this COPYING is GPL2
if (WIN32)
	install (FILES COPYING.WIN32 DESTINATION "${KADU_INSTALL_DATA_DIR}")
else ()
	install (FILES COPYING.GPL2 COPYING.LGPL2.1 DESTINATION "${KADU_INSTALL_DATA_DIR}")
endif ()

=== anonymous_check/CMakeLists.txt ===
project (anonymous_check)

# minimal required versions
cmake_minimum_required (VERSION 2.8)
set (QT_MIN_VERSION "4.8.0")
set (CMAKE_MIN_VERSION "2.8.0")

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
	anonymous_check.cpp
	anonymous_check-plugin.cpp
	anonymous_info.cpp
)

kadu_plugin (anonymous_check
	PLUGIN_SOURCES ${SOURCES}
)

=== globalhotkeys/CMakeLists.txt ===
project( globalhotkeys )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	globalhotkeys.cpp
	api.cpp
	buddiesmenu.cpp
	conf.cpp
	functions.cpp
	globalmenu.cpp
	globalwidgetmanager.cpp
	hotkey.cpp
	hotkeyedit.cpp
	serializableqstringlist.cpp
	statusesmenu.cpp
	wideiconmenustyle.cpp
)

set( MOC_SOURCES
	globalhotkeys.h
	buddiesmenu.h
	conf.h
	functions.h
	globalmenu.h
	globalwidgetmanager.h
	hotkeyedit.h
	statusesmenu.h
)

set( TRANSLATION_SOURCES
	translations/globalhotkeys_en.ts
	translations/globalhotkeys_cs.ts
	translations/globalhotkeys_it.ts
	translations/globalhotkeys_pl.ts
)

set( CONFIGURATION_FILES
	configuration/globalhotkeys.ui
)

kadu_plugin( globalhotkeys
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== import_history/CMakeLists.txt ===
project (import_history)

# minimal required versions
cmake_minimum_required (VERSION 2.8)
set (QT_MIN_VERSION "4.8.0")
set (CMAKE_MIN_VERSION "2.8.0")

find_package (Kadu REQUIRED CONFIG)

include (FindPkgConfig)

set (SOURCES
  import_history.cpp
  gui/gui.cpp
  importers/importer.cpp
  importers/gg7/crc32.cpp
  importers/gg7/ggimporter.cpp
  importers/gg8/gg8importer.cpp
  misc/memfile.cpp
)

set (CONFIGURATION_FILES
)

pkg_search_module (LIBGADU REQUIRED libgadu)
pkg_search_module (SQLITE3 REQUIRED sqlite3)

include_directories (${LIBGADU_INCLUDE_DIRS} ${SQLITE3_INCLUDE_DIRS})
link_directories (${LIBGADU_LIBRARY_DIRS} ${SQLITE3_LIBRARY_DIRS})

#qt5_wrap_ui(import_history_UIS gui/import_history.ui)
include_directories (${CMAKE_CURRENT_BINARY_DIR})

kadu_plugin(import_history
  PLUGIN_SOURCES ${SOURCES} ${import_history_UIS}
  PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
  PLUGIN_LIBRARIES ${LIBGADU_LIBRARIES} ${SQLITE3_LIBRARIES}
  PLUGIN_DEPENDENCIES history gadu_protocol
)

=== kadu-core/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

if (ENABLE_DEVELOPER_BUILD AND NOT MSVC AND NOT APPLE)
	set (FAST_LINKING_DEFAULT ON)
else ()
	set (FAST_LINKING_DEFAULT OFF)
endif ()
option (FAST_LINKING "Enable for linking optimized for low RAM (works best with GCC and GNU ld)" "${FAST_LINKING_DEFAULT}")

if (FAST_LINKING)
	message (STATUS "Fast (re)linking enabled")
else ()
	message (STATUS "Fast (re)linking disabled")
endif ()

# if ((NOT DEFINED NETWORK_IMPLEMENTATION AND NOT Qt5Core_FOUND) OR "${NETWORK_IMPLEMENTATION}" STREQUAL "ntrack")
# 	find_package (QNtrack 010)
# endif ()

if (NOT DEFINED NETWORK_IMPLEMENTATION)
#	if (QNTRACK_FOUND)
#		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: ntrack")
#		set (NETWORK_IMPLEMENTATION "ntrack")
#	else ()
		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: Qt")
		set (NETWORK_IMPLEMENTATION "Qt")
#	endif ()
endif ()

set (NETWORK_IMPLEMENTATION "${NETWORK_IMPLEMENTATION}" CACHE STRING "Select network-aware implementation (Qt/ntrack/dummy)" FORCE)

if ("${NETWORK_IMPLEMENTATION}" STREQUAL "ntrack")
	list (APPEND ADDITIONAL_LIBKADU_LIBRARIES ${QNTRACK_LIBRARIES})
endif ()
# The rest of NETWORK_IMPLEMENTATION stuff is handled in network/CMakeLists.txt.

# injeqt
find_package (PkgConfig)
pkg_check_modules (INJEQT REQUIRED injeqt>=1.0.0)
set (INJEQT_DEFINITIONS ${INJEQT_CFLAGS_OTHER})
include_directories (${INJEQT_INCLUDEDIR})
link_directories (${INJEQT_LIBRARY_DIRS})

list (APPEND ADDITIONAL_LIBKADU_LIBRARIES ${INJEQT_LIBRARIES})
list (APPEND ADDITIONAL_LIBRARIES ${INJEQT_LIBRARIES})

configure_file (kadu-config.h.in "${CMAKE_CURRENT_BINARY_DIR}/kadu-config.h" ESCAPE_QUOTES)
include_directories ("${CMAKE_CURRENT_BINARY_DIR}")

set (kadu_SRCS
	activate.cpp
	attention-service.cpp
	debug.cpp
	languages-manager.cpp
	themes.cpp
	updates.cpp

	os/single-application/long-lived-lock-file.cpp
	os/single-application/single-application.cpp
)

if (WIN32)
	list (APPEND kadu_SRCS
		kadu.rc
	)
endif ()

if (UNIX AND NOT APPLE)
	list (APPEND kadu_SRCS
		os/x11/x11tools.cpp
	)
endif ()

set (main_SRCS
	main.cpp

	os/single-application/long-lived-lock-file.cpp
	os/single-application/single-application.cpp
)

if (WIN32)
	list (APPEND main_SRCS
		main_win32.cpp
		kadu.rc
	)
else ()
	list (APPEND main_SRCS
		main_unix.cpp
	)
endif ()

set (kadu_MOC_SRCS
	themes.h
	updates.h
)

set (kadu_SUBDIRS
	accounts
	avatars
	buddies
	chat
	chat-style
	compression
	configuration
	contacts
	core
	dom
	execution-arguments
	file-system
	file-transfer
	formatted-string
	gui
	icons
	identities
	message
	misc
	model
	multilogon
	network
	notification
	os
	parser
	plugin
	protocols
	qt
	roster
	services
	ssl
	status
	storage
	talkable
	themes
	url-handlers
)

find_package (LibArchive 2.6.0 REQUIRED)
include (CheckLibraryExists)
check_library_exists ("${LibArchive_LIBRARIES}" "archive_write_set_compression_lzma" "" have_libarchive_lzma_support)
check_library_exists ("${LibArchive_LIBRARIES}" "archive_write_set_compression_xz" "" have_libarchive_xz_support)
if (NOT have_libarchive_lzma_support OR NOT have_libarchive_xz_support)
	message (SEND_ERROR "Your libarchive does not have support for lzma and/or xz archives.")
endif ()

include_directories (${LibArchive_INCLUDE_DIRS})
list (APPEND ADDITIONAL_LIBKADU_LIBRARIES ${LibArchive_LIBRARIES})

if (UNIX AND NOT APPLE)
	find_package (X11 REQUIRED COMPONENTS X11 Xutil Xfixes)
	if (X11_FOUND AND X11_Xutil_FOUND AND X11_Xfixes_FOUND)
		message (STATUS "Found required X11 libraries: ${X11_X11_LIB};${X11_Xfixes_LIB}")
	else ()
		message (FATAL_ERROR "Could NOT find X11 or X11 Xfixes extension")
	endif ()

	include_directories (${X11_INCLUDE_DIR})
	list (APPEND ADDITIONAL_LIBKADU_LIBRARIES ${X11_X11_LIB} ${X11_Xfixes_LIB})
endif ()

if (APPLE)
	list (APPEND ADDITIONAL_LIBKADU_LIBRARIES "-framework carbon")
endif ()

macro (kadu_subdirectory SUBDIR SRCS MOC_SRCS ADDITIONAL_INCLUDES)
	if (FAST_LINKING)
		add_library (${SUBDIR}
			STATIC
			${SRCS}
			${MOC_SRCS}
		)
		kadu_set_flags (${SUBDIR})
		set_property (TARGET ${SUBDIR} PROPERTY POSITION_INDEPENDENT_CODE TRUE)
		target_compile_definitions (${SUBDIR} PRIVATE libkadu_EXPORTS)
	else ()
		set (tmp "")
		foreach (SRC ${SRCS})
			list (APPEND tmp "${SUBDIR}/${SRC}")
		endforeach ()

		set (tmp_moc "")
		foreach (MOC_SRC ${MOC_SRCS})
			list (APPEND tmp_moc "${SUBDIR}/${MOC_SRC}")
		endforeach ()

		set (${SUBDIR}_SRCS "${tmp}" PARENT_SCOPE)
		set (${SUBDIR}_MOC_SRCS "${tmp_moc}" PARENT_SCOPE)
		set (${SUBDIR}_INCLUDES "${ADDITIONAL_INCLUDES}" PARENT_SCOPE)
	endif ()
endmacro ()

foreach (ARG ${kadu_SUBDIRS})
	add_subdirectory (${ARG})

	if (NOT FAST_LINKING)
		list (APPEND kadu_SUBDIRS_SRCS ${${ARG}_SRCS} ${${ARG}_MOC_SRCS})
		include_directories (${${ARG}_INCLUDES})
	endif ()
endforeach ()

add_library (libkadu SHARED ${kadu_SRCS} ${kadu_MOC_SRCS} ${kadu_SUBDIRS_SRCS})
kadu_set_flags (libkadu)
set_property (TARGET libkadu PROPERTY PREFIX "")

if (FAST_LINKING)
	if (APPLE)
		target_link_libraries (libkadu LINK_PRIVATE -Wl,-all_load ${kadu_SUBDIRS})
	else ()
		target_link_libraries (libkadu LINK_PRIVATE -Wl,--start-group -Wl,--whole-archive ${kadu_SUBDIRS} -Wl,--no-whole-archive -Wl,--end-group)
	endif ()
endif ()

qt5_use_modules (libkadu LINK_PRIVATE Core Gui Network Qml Quick QuickWidgets WebKit WebKitWidgets Widgets Xml)
if (UNIX AND NOT APPLE)
	qt5_use_modules (libkadu LINK_PRIVATE DBus X11Extras)
endif ()
if (WIN32)
	qt5_use_modules (libkadu LINK_PRIVATE WinExtras)
endif ()

target_link_libraries (libkadu LINK_PRIVATE ${ADDITIONAL_LIBKADU_LIBRARIES})

find_package (QCA2 REQUIRED)
include_directories (${QCA2_INCLUDE_DIR})

add_executable (kadu WIN32 ${main_SRCS})
kadu_set_flags (kadu)
qt5_use_modules (kadu LINK_PRIVATE Core Gui Widgets Network Xml)
target_link_libraries (kadu LINK_PRIVATE libkadu ${ADDITIONAL_LIBRARIES} ${QCA2_LIBRARIES})

if (NOT IS_ABSOLUTE "${KADU_INSTALL_LIB_DIR}")
	set (install_full_lib_dir "${CMAKE_INSTALL_PREFIX}/${KADU_INSTALL_LIB_DIR}")
else ()
	set (install_full_lib_dir "${KADU_INSTALL_LIB_DIR}")
endif ()

set_target_properties (kadu PROPERTIES
	INSTALL_RPATH "${install_full_lib_dir}/kadu"
	BUILD_WITH_INSTALL_RPATH TRUE
)

install (TARGETS libkadu kadu
	EXPORT KaduTargets
	LIBRARY DESTINATION ${KADU_INSTALL_LIB_DIR}/kadu
	RUNTIME DESTINATION ${KADU_INSTALL_BIN_DIR}
)
# TODO this WIN32 check is a workaround for an error on Linux
if (WIN32 AND KADU_INSTALL_SDK)
	install (TARGETS libkadu ARCHIVE DESTINATION ${KADU_INSTALL_SDK_DIR}/lib)
endif ()

if (WIN32)
	add_executable (kadu_c ${main_SRCS})
	kadu_set_flags (kadu_c)
	qt5_use_modules (kadu_c LINK_PRIVATE Core Gui Widgets Network Xml)
	target_link_libraries (kadu_c LINK_PRIVATE libkadu ${ADDITIONAL_LIBRARIES} ${QCA2_LIBRARIES})

	# Do not link against qtmain on Windows
	cmake_policy(SET CMP0020 OLD)

	target_compile_definitions (kadu_c PRIVATE KADU_CONSOLE)

	set_property (TARGET kadu_c PROPERTY Qt5_NO_LINK_QTMAIN TRUE)
	set_property (TARGET kadu PROPERTY Qt5_NO_LINK_QTMAIN TRUE)
	set_property (TARGET libkadu PROPERTY Qt5_NO_LINK_QTMAIN TRUE)

	target_link_libraries (kadu LINK_PRIVATE ws2_32)
	target_link_libraries (libkadu LINK_PRIVATE ws2_32)
	target_link_libraries (kadu_c LINK_PRIVATE ws2_32)

	install (TARGETS kadu_c DESTINATION ${KADU_INSTALL_BIN_DIR})

	file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/qt.conf" "[Paths]\nPlugins = qt-plugins\nTranslations = translations\n")
	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/qt.conf" "kadu.ico" DESTINATION "${KADU_INSTALL_BIN_DIR}")
endif ()

install (TARGETS kadu DESTINATION ${KADU_INSTALL_BIN_DIR})

if (UNIX AND NOT APPLE)
	configure_file (kadu.desktop.in "${CMAKE_CURRENT_BINARY_DIR}/${KADU_DESKTOP_FILE_NAME}")
	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/${KADU_DESKTOP_FILE_NAME}" DESTINATION "${KADU_DESKTOP_FILE_DIR}")

	install (FILES hi16-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps" RENAME kadu.png)
	install (FILES hi22-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/22x22/apps" RENAME kadu.png)
	install (FILES hi24-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/24x24/apps" RENAME kadu.png)
	install (FILES hi32-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps" RENAME kadu.png)
	install (FILES hi48-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps" RENAME kadu.png)
	install (FILES hi64-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps" RENAME kadu.png)
	install (FILES hi128-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps" RENAME kadu.png)
	install (FILES hi256-app-kadu.png DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps" RENAME kadu.png)
endif ()

install (FILES "chat-style/engine/chat-scripts.js" DESTINATION "${KADU_INSTALL_DATA_DIR}/scripts")

# install api headers
# how to get list: find . -name '*.h' -exec dirname {} +|sort|uniq|sed -e 's|\./||' -e 's|^|\t|'
# TODO: consider using file (GLOB_RECURSE) command here
kadu_api_directories (kadu-core
	.
	accounts
	accounts/filter
	accounts/model
	avatars
	buddies
	buddies/model
	chat
	chat/model
	chat/style-engine
	chat-style/engine/chat-engine-adium
	chat-style/engine/chat-engine-kadu
	chat/type
	compression
	configuration
	contacts
	contacts/model
	core
	dom
	execution-arguments
	file-system
	file-transfer
	file-transfer/gui
	formatted-string
	gui
	gui/actions
	gui/actions/chat
	gui/configuration
	gui/menu
	gui/model
	gui/services
	gui/widgets
	gui/widgets/configuration
	gui/widgets/dialog
	gui/widgets/chat-widget
	gui/widgets/group-tab-bar
	gui/widgets/webkit-messages-view
	chat-style/engine
	gui/windows
	gui/windows/open-chat-with
	icons
	identities
	identities/model
	message
	misc
	model
	multilogon
	multilogon/model
	network
	network/proxy
	network/proxy/model
	notification
	notification/listener
	notification/notification
	os
	os/generic
	os/qtsingleapplication
	parser
	plugin
	plugin/activation
	plugin/metadata
	plugin/model
	plugin/state
	protocols
	protocols/filter
	protocols/model
	protocols/services
	protocols/services/roster
	provider
	roster
	qt
	services
	ssl
	ssl/gui
	status
	storage
	talkable
	talkable/filter
	talkable/model
	themes
	url-handlers
)

=== kadu_completion/CMakeLists.txt ===
project (kadu_completion)

# minimal required versions
cmake_minimum_required (VERSION 2.8)
set (QT_MIN_VERSION "4.8.0")
set (CMAKE_MIN_VERSION "2.8.0")

find_package (Kadu REQUIRED CONFIG)

set (SOURCES
    completion_context.cpp
    kadu_completion.cpp
    kadu_completion_plugin.cpp
)

set (DATA_FILES
    data/list.txt
)

kadu_plugin (kadu_completion
    PLUGIN_SOURCES ${SOURCES}
)

install (FILES ${DATA_FILES}
    DESTINATION ${KADU_INSTALL_PLUGINS_DATA_DIR}/data/kadu_completion)

=== kthxbye/CMakeLists.txt ===
install (CODE
	"message (STATUS \"\")
	message (STATUS \" **************************************\")
	message (STATUS \" * Kadu is now successfully installed *\")
	message (STATUS \" **************************************\")
	message (STATUS \"\")
	message (STATUS \" Thanks for choosing Kadu Communicator and ENJOY!!!\")
	message (STATUS \"\")
	message (STATUS \"                                  Kadu Team\")
	message (STATUS \"\")"
)

=== lednotify/CMakeLists.txt ===
project( lednotify )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	ledblinker.cpp
	lednotify.cpp
)

set( MOC_SOURCES
	ledblinker.h
	lednotify.h
)

if( WIN32 )
	list( APPEND SOURCES leddriver_win32.cpp )
	include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
else( WIN32 )
	list( APPEND SOURCES leddriver_x11.cpp )
endif( WIN32 )

set( TRANSLATION_SOURCES
	translations/lednotify_en.ts
	translations/lednotify_cs.ts
	translations/lednotify_pl.ts
)

set( CONFIGURATION_FILES
	configuration/lednotify.ui
)

kadu_plugin( lednotify
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== messagessplitter/CMakeLists.txt ===
project( messagessplitter )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	messagessplitter.cpp
)

set( MOC_SOURCES
	messagessplitter.h
)

set( TRANSLATION_SOURCES
	translations/messagessplitter_en.ts
	translations/messagessplitter_cs.ts
	translations/messagessplitter_pl.ts
)

set( CONFIGURATION_FILES
	configuration/messagessplitter.ui
)

kadu_plugin( messagessplitter
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
	PLUGIN_DEPENDENCIES gadu_protocol encryption_ng
)

=== nextinfo/CMakeLists.txt ===
project( nextinfo )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	nextinfo.cpp
	buddynextinfodata.cpp
	extendedinformationwidgets.cpp
	photowidget.cpp
)

set( MOC_SOURCES
	nextinfo.h
	extendedinformationwidgets.h
	photowidget.h
)

set( TRANSLATION_SOURCES
	translations/nextinfo_en.ts
	translations/nextinfo_cs.ts
	translations/nextinfo_fr.ts
	translations/nextinfo_pl.ts
)

set( CONFIGURATION_FILES
	configuration/nextinfo.ui
)

set( QT_USE_QTSCRIPT 1 )
include( ${QT_USE_FILE} )

kadu_plugin( nextinfo
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

target_link_libraries( nextinfo ${QT_QTSCRIPT_LIBRARY} )

=== plugins/CMakeLists.txt ===
option (BUILD_PLUGINS "Switch to OFF if you do not want to build plugins" ON)

if (BUILD_PLUGINS)
	foreach (plugin ${COMPILE_PLUGINS})
		file (STRINGS "${plugin}/${plugin}.desc" plugin_dependencies REGEX "^Dependencies")
		string (REPLACE "Dependencies=" "" plugin_dependencies "${plugin_dependencies}")
		string (REPLACE " " ";" plugin_dependencies "${plugin_dependencies}")
		foreach (dependency ${plugin_dependencies})
			list (FIND COMPILE_PLUGINS "${dependency}" index)
			if (index EQUAL -1)
				message (FATAL_ERROR "`${plugin}' plugin requires `${dependency}' plugin. Please enable `${dependency}' plugin.")
			endif ()
		endforeach ()

		message (STATUS "Plugin: " ${plugin})
		add_subdirectory (${plugin})
	endforeach ()
endif ()

if (KADU_INSTALL_SDK)
	if (WIN32)
		install (FILES pluginbase.rc.in DESTINATION "${KADU_INSTALL_SDK_DIR}/plugins")
	endif ()

	install (FILES PluginConfig.cmake.in DESTINATION "${KADU_INSTALL_SDK_DIR}/plugins")
endif ()

=== tests/CMakeLists.txt ===
include_directories(".")

# injeqt
find_package (PkgConfig)
pkg_check_modules (INJEQT REQUIRED injeqt>=1.0.0)
set (INJEQT_DEFINITIONS ${INJEQT_CFLAGS_OTHER})
include_directories (${INJEQT_INCLUDEDIR})
link_directories (${INJEQT_LIBRARY_DIRS})

# kadu_add_test (<name> source1 source2 ... sourceN)
function (kadu_add_test name_)
	set (pluginName)

	file (RELATIVE_PATH sourcePath "${CMAKE_SOURCE_DIR}/tests" "${CMAKE_CURRENT_SOURCE_DIR}")
	if ("${sourcePath}" MATCHES "^[^/]+/plugins/.*")
		string (REGEX REPLACE "^[^/]+/plugins/" "" pluginName "${sourcePath}")
		string (REGEX REPLACE "^[^/]*/.*" "" pluginName "${pluginName}")
		# Do not add the test if it tests a plugin we do not have.
		if (NOT "${pluginName}" STREQUAL "" AND NOT TARGET ${pluginName})
			return ()
		endif ()
	endif ()

	get_filename_component (exeDir "${CMAKE_CURRENT_BINARY_DIR}/${name_}" PATH)
	file (MAKE_DIRECTORY "${exeDir}")

	add_executable (${name_} ${ARGN})
	kadu_set_flags (${name_})
	if (NOT MSVC)
		set_property (TARGET ${name_} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error")
	endif ()
	add_test ("${sourcePath}/${name_}" ${name_})

	qt5_use_modules (${name_} LINK_PRIVATE Core Gui Network Qml Quick QuickWidgets Test WebKit WebKitWidgets Widgets Xml)

	# Add libkadu after the plugin so that --as-needed won't drop anything
	# needed by the plugin.
	target_link_libraries (${name_} LINK_PRIVATE ${pluginName} libkadu)
endfunction ()

add_subdirectory (unit)

=== debian/changelog ===
kadu (3.0~rc1-1) unstable; urgency=medium

  * New upstream release
  * Added libqxmpp-dev to Build-Depends
  * Removed debian/patches/04-int_narrowing_fix.patch. Issue fixed
    upstream.

 -- Patryk Cisek <patryk@debian.org>  Fri, 25 Dec 2015 18:07:46 +0100

kadu (2.1-2) unstable; urgency=medium

  * Added debian/patches/04-int_narrowing_fix.patch (Closes: #795488)
  * Added description and author to 03-exclude_unsupported_plugins.patch

 -- Patryk Cisek <patryk@debian.org>  Sat, 17 Oct 2015 14:57:17 +0200

kadu (2.1-1) unstable; urgency=medium

  * New upstream release (Closes: #795488)
  * Updated debian/patches/02-about-dialog.patch for Kadu 2.1
  * Removed 03-exclude_unsupported_plugins.patch, as it's been applied
    upstream.
  * Removed kadu.menu, as there's a corresponding .desktop file in
    place.
  * Removed obsolete url from debian/watch

 -- Patryk Cisek <patryk@debian.org>  Sun, 11 Oct 2015 12:55:38 +0200

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: git://git.debian.org/users/patryk/kadu.git
Vcs-Browser: http://git.debian.org/?p=users/patryk/kadu.git
Build-Depends: bzip2,
               chrpath,
               cmake (>=2.6),
               debhelper (>= 9),
               enchant,
               libarchive-dev,
               libasound2-dev,
               libaudio-dev,
               libdbus-1-dev,
               libenchant-dev,
               libgadu-dev,
               libidn11-dev,
               libindicate-qt-dev,
               libinjeqt-dev,
               libmpdclient-dev,
               libotr5-dev,
               libphonon4qt5-dev,
               libqca-qt5-2-dev,
               libqca2-dev,
               libqt4-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libqt5xmlpatterns5-dev,
               libqtwebkit-dev,
               libqxmpp-dev,
               libsndfile1-dev (>= 1.0),
               libsqlite3-dev,
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               pkgconf,
               qtbase5-dev,
               qtmultimedia5-dev,
               qtquick1-5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://kadu.net

Package: kadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: kadu-common (= ${source:Version}),
         libkadu (= ${binary:Version}),
         libqca2-plugin-ossl,
         libqt4-sql-sqlite,
         libqt4-svg,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kadu-external-modules (<< 1.0)
Replaces: kadu-external-modules (<< 1.0)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: libkadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package contains libkadu, which is used by Kadu.

Package: kadu-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files needed to compile plugins for kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides development files needed to compile plugins for Kadu.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

export DEB_BUILD_HARDENING=1

PKG_DIR=$(shell pwd)
BUILD_DIR=$(CURDIR)/build-dir
INSTALL_DIR=$(PKG_DIR)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)


configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir $(BUILD_DIR)
	find . -name '*.o' -delete
	bash debian/handle_external.sh copy
	cd $(BUILD_DIR) && cmake -DCMAKE_C_FLAGS="$(CFLAGS)" -DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" -DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" -DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" -DCMAKE_SKIP_RPATH=False -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr $(PKG_DIR)
	touch configure-stamp

#Architecture
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	cd $(BUILD_DIR) && $(MAKE) VERBOSE=1
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	test -d $(BUILD_DIR) && cd $(BUILD_DIR) && $(MAKE) clean || true
	rm -rf $(BUILD_DIR)
	bash debian/handle_external.sh remove
	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	# Remove all license files
	find $(INSTALL_DIR) -name '[lL][iI][cC][eE][nN][sS][eE].txt' -delete
	# Remove all thumbnails files
	find $(INSTALL_DIR) -name Thumbs.db -delete
	rm -f $(INSTALL_DIR)/usr/share/kadu/themes/sounds/bns/sound.conf~
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_prep -s 
	dh_installdirs -s
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	cp $(INSTALL_DIR)/usr/share/kadu/ChangeLog debian/kadu/usr/share/doc/kadu/about-changes-tab.txt
	# Rmove some cruft
	rm -f $(INSTALL_DIR)/usr/share/kadu/modules/data/osd_hints/License
	# Remove RPATH from all the plugins
	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/kadu/plugins/*.so
	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress -XAUTHORS.html -XAUTHORS -XTHANKS -XLICENSE -Xabout-changes-tab.txt
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep

.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure

=== debian/watch ===
version=3

opts="uversionmangle=s/-(alpha|beta|rc)/~$1/" \
http://www.kadu.net/download/stable/kadu-(.*)\.tar\.bz2

## kadu 3.0

=== debian/changelog ===
kadu (3.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop all QT4 and no needed depends. (Closes: #784472, #808697)
  * Update description for QT5.
  * Use secured links for VCS.
  * Enable parallel building. (Closes: #821275)
  * Bump Standards-Version to 3.9.8.
  * Fix watch file.

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Wed, 15 Jun 2016 20:12:26 +0200

kadu (3.0-1) unstable; urgency=medium

  * New upstream release
  * Bumped Standards-Version

 -- Patryk Cisek <patryk@debian.org>  Fri, 15 Apr 2016 10:04:09 +0200

kadu (3.0~rc1-1.1) unstable; urgency=medium

  * Non-maintainer upload with maintainer's permission.
  * Drop build-dependency on libindicate-qt-dev. (Closes: #812240)

 -- Felix Geyer <fgeyer@debian.org>  Wed, 23 Mar 2016 18:23:11 +0100

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: https://anonscm.debian.org/git/users/patryk/kadu.git
Vcs-Browser: https://anonscm.debian.org/cgit/users/patryk/kadu.git
Build-Depends: bzip2,
               chrpath,
               cmake (>=2.6),
               debhelper (>= 9),
               enchant,
               libarchive-dev,
               libasound2-dev,
               libaudio-dev,
               libdbus-1-dev,
               libenchant-dev,
               libgadu-dev,
               libidn11-dev,
               libinjeqt-dev,
               libmpdclient-dev,
               libotr5-dev,
               libphonon4qt5-dev,
               libqca-qt5-2-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libqt5xmlpatterns5-dev,
               libqxmpp-dev,
               libsndfile1-dev (>= 1.0),
               libsqlite3-dev,
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               pkgconf,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://kadu.net

Package: kadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: kadu-common (= ${source:Version}),
         libkadu (= ${binary:Version}),
         libqca-qt5-2-plugins,
         libqt5sql5-sqlite,
         libqt5svg5,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kadu-external-modules (<< 1.0)
Replaces: kadu-external-modules (<< 1.0)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt5 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: libkadu
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt5 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package contains libkadu, which is used by Kadu.

Package: kadu-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt5 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files needed to compile plugins for kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt5 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides development files needed to compile plugins for Kadu.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt5 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,10 @@
 CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
 CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
 LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
+
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	NJOBS:=-j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+endif
 
 
 configure: configure-stamp
@@ -28,7 +32,7 @@
 
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp
-	cd $(BUILD_DIR) && $(MAKE) VERBOSE=1
+	cd $(BUILD_DIR) && $(MAKE) $(NJOBS) VERBOSE=1
 	touch $@
 
 build-indep: build-indep-stamp
